// C Source File
// Created 3/31/2005; 4:06:40 PM

#define USE_TI89              // Compile for TI-89
#define USE_TI92PLUS          // Compile for TI-92 Plus
#define USE_V200              // Compile for V200

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

// Main Function
void _main(void)
{
	unsigned char left[] = {0x00,0x10,0x30,0x7F,0xFF,0x7F,0x30,0x10}, right[] = {0x00,0x08,0x0C,0xFE,0xFF,0xFE,0x0C,0x08}, up[] = {0x08,0x1C,0x3E,0x7F,0x1C,0x1C,0x1C,0x1C}, down[] = {0x1C,0x1C,0x1C,0x1C,0x7F,0x3E,0x1C,0x08};
	short move=1, pt=0, p=0, y=90, t=0, ranum=0, l=0, r=0, u=0, d=0, press=0, skip=0, words=0, x=0, line=0,wait=0, points=0, combo=0;
	char combostr[0], pointstr[0],  screen [BITMAP_HDR_SIZE + 160*100/8]; // or 2004 if you like it more;
	long h=0;
	SCR_RECT full_screen = {{0, 0, 159, 99}};
	
	OSSetSR (0x0700);

	// Title Screen
	while(line<=99) {
		DrawLine(0,line,159,line,A_REVERSE);
		line++;
		while(wait!=5000) {
			wait++;
		}
		wait=0;
	}
	line=99;
	while(line>=0) {
		DrawLine(0,line,159,line,A_NORMAL);
		line--;
		while(wait!=5000) {
			wait++;
		}
		wait=0;
		if(line<=87) {
			FontSetSys(F_8x10);
			DrawStr(35,line+2,"Dance Crazy!",A_REVERSE);
			DrawLine(0,line+12,159,line+12,A_NORMAL);
		}
		if(line<=47) {
			FontSetSys(F_6x8);
			DrawStr(27,line+40,"By Peter Fernandes",A_REVERSE);
			DrawLine(0,line+48,159,line+48,A_NORMAL);
		}
	}
	Sprite8(30,line+71,8,left,LCD_MEM,SPRT_XOR);
	Sprite8(60,line+71,8,right,LCD_MEM,SPRT_XOR);
	Sprite8(90,line+71,8,up,LCD_MEM,SPRT_XOR);
	Sprite8(120,line+71,8,down,LCD_MEM,SPRT_XOR);
	
	FontSetSys(F_4x6);
	DrawStr(60,87,"Press Enter",A_REVERSE);
	while(y!=100) {
		press=_keytest(RR_ENTER);
		if(press==1) {
			goto begin;
		}
	}
	begin:
	ClrScr();
	FontSetSys(F_8x10);
	
	Sprite8(30,4,8,left,LCD_MEM,SPRT_XOR);
	Sprite8(60,4,8,right,LCD_MEM,SPRT_XOR);
	Sprite8(90,4,8,up,LCD_MEM,SPRT_XOR);
	Sprite8(120,4,8,down,LCD_MEM,SPRT_XOR);
	
	
	DrawLine(0,25,159,25,A_NORMAL);
	DrawLine(0,0,159,0,A_NORMAL);
	DrawLine(25,0,25,25,A_NORMAL);
	DrawLine(43,0,43,25,A_NORMAL);
	DrawLine(55,0,55,25,A_NORMAL);
	DrawLine(73,0,73,25,A_NORMAL);
	DrawLine(85,0,85,25,A_NORMAL);
	DrawLine(103,0,103,25,A_NORMAL);
	DrawLine(115,0,115,25,A_NORMAL);
	DrawLine(133,0,133,25,A_NORMAL);
	DrawLine(26,25,42,25,A_REVERSE);
	DrawLine(56,25,72,25,A_REVERSE);
	DrawLine(86,25,102,25,A_REVERSE);
	DrawLine(116,25,132,25,A_REVERSE);
	DrawStr(30,50,"Bust a Move!",A_NORMAL);
	FontSetSys(F_4x6);
	DrawStr(2,5,"Points",A_NORMAL);
	DrawStr(134,5,"Combos:",A_NORMAL);
	
	// Continuous loop
	while(y!=100) {
	randomize();
	ranum=random(4);
	sprintf (combostr, "%d", combo);
	DrawLine(144,15,155,15,A_REVERSE);
	DrawLine(144,16,155,16,A_REVERSE);
	DrawLine(144,17,155,17,A_REVERSE);
	DrawLine(144,18,155,18,A_REVERSE);
	DrawLine(144,19,155,19,A_REVERSE);
	DrawStr(144,15,combostr,A_NORMAL);
	sprintf(pointstr, "%d", points);
	DrawLine(3,15,19,15,A_REVERSE);
	DrawLine(3,16,19,16,A_REVERSE);
	DrawLine(3,17,19,17,A_REVERSE);
	DrawLine(3,18,19,18,A_REVERSE);
	DrawLine(3,19,19,19,A_REVERSE);
	DrawStr(3,15,pointstr,A_NORMAL);
	skip=0, words=0;
	// Sprite loop
	while(y>0) {
		if(move==1) {
			if(y==70) {
				FontSetSys(F_8x10);
				DrawStr(30,50,"Bust a Move!",A_XOR);
				FontSetSys(F_4x6);
			}
		}
		if(pt==1) {
			p++;
		}
		press=_keytest (RR_F1);
		if(press==1) {
			if(pt==1) {
				if(p>=10) {
					goto pause;
			}
				}
			if(pt==0) {
				goto pause;
			}
		}
		play:
		if(y==55) {
		DrawLine(25,40,148,40,A_REVERSE);
		DrawLine(25,41,148,41,A_REVERSE);
		DrawLine(25,42,148,42,A_REVERSE);
		DrawLine(25,43,148,43,A_REVERSE);
		DrawLine(25,44,148,44,A_REVERSE);
		}
		// Note conditionals go here 
		
		t++;
		if(ranum==0) {
			l=1;
		}
		if(ranum==1) {
			r=1;
		}
		if(ranum==2) {
			u=1;
		}
		if(ranum==3) {
			d=1;
		}
		// Remove the sprite
		if(l==1) {
			Sprite8(30,y,8,left,LCD_MEM,SPRT_XOR);
		}
		if(r==1) {
			Sprite8(60,y,8,right,LCD_MEM,SPRT_XOR);
		}
		if(u==1) {
			Sprite8(90,y,8,up,LCD_MEM,SPRT_XOR);
		}
		if(d==1) {
			Sprite8(120,y,8,down,LCD_MEM,SPRT_XOR);
		}
		// Remove the sprite's first position
		if(t==1) {
			if(l==1) {
				Sprite8(30,y,8,left,LCD_MEM,SPRT_XOR);
			}
			if(r==1) {
				Sprite8(60,y,8,right,LCD_MEM,SPRT_XOR);
			}
			if(u==1) {
				Sprite8(90,y,8,up,LCD_MEM,SPRT_XOR);
			}
			if(d==1) {
				Sprite8(120,y,8,down,LCD_MEM,SPRT_XOR);
			}
		}
		y--;
		// Redraw the sprite
		if(l==1) {
		Sprite8(30,y,8,left,LCD_MEM,SPRT_XOR);
		}
		if(r==1) {
		Sprite8(60,y,8,right,LCD_MEM,SPRT_XOR);
		}
		if(u==1) {
		Sprite8(90,y,8,up,LCD_MEM,SPRT_XOR);
		}
		if(d==1) {
		Sprite8(120,y,8,down,LCD_MEM,SPRT_XOR);
		}
		// Test for imput
		// When y equals 8
		if(y==8) {
			if(l==1) {
				press=_keytest (RR_LEFT);
				if(press==1) {
					DrawStr(27,40,"Miss",A_NORMAL);
					press=0, skip=1, combo=0;
				}
			}
			if(r==1) {
				press=_keytest (RR_RIGHT);
				if(press==1) {
					DrawStr(57,40,"Miss",A_NORMAL);
					press=0, skip=1, combo=0;
				}
			}
			if(u==1) {
				press=_keytest (RR_UP);
				if(press==1) {
					DrawStr(87,40,"Miss",A_NORMAL);
					press=0,skip=1, combo=0;
				}
			}
			if(d==1) {
				press=_keytest (RR_DOWN);
				if(press==1) {
					DrawStr(117,40,"Miss",A_NORMAL);
					press=0, skip=1, combo=0;
				}
			}
		}
		// When y equals 7
		if(y==7) {
			if(skip==1) {
				goto speed;
			}
			if(l==1) {
				press=_keytest (RR_LEFT);
				if(press==1) {
					DrawStr(27,40,"Bad",A_NORMAL);
					press=0, skip=1, points+=1, combo=0;
				}
			}
			if(r==1) {
				press=_keytest (RR_RIGHT);
				if(press==1) {
					DrawStr(57,40,"Bad",A_NORMAL);
					press=0, skip=1, points+=1, combo=0;
				}
			}
			if(u==1) {
				press=_keytest (RR_UP);
				if(press==1) {
					DrawStr(87,40,"Bad",A_NORMAL);
					press=0, skip=1, points+=1, combo=0;
				}
			}
			if(d==1) {
				press=_keytest (RR_DOWN);
				if(press==1) {
					DrawStr(117, 40,"Bad",A_NORMAL);
					press=0, skip=1, points+=1, combo=0;
				}
			}
		}
		// When y equals 6
		if(y==6) {
			if(skip==1) {
				goto speed;
			}
			if(l==1) {
				press=_keytest (RR_LEFT);
				if(press==1) {
					DrawStr(27,40,"Good!",A_NORMAL);
					press=0, skip=1, points+=5, combo=0;
				}
			}
			if(r==1) {
				press=_keytest (RR_RIGHT);
				if(press==1) {
					DrawStr(57,40,"Good!",A_NORMAL);
					press=0, skip=1, points+=5, combo=0;
				}
			}
			if(u==1) {
				press=_keytest (RR_UP);
				if(press==1) {
					DrawStr(87,40,"Good!",A_NORMAL);
					press=0, skip=1, points+=5, combo=0;
				}
			}
			if(d==1) {
				press=_keytest (RR_DOWN);
				if(press==1) {
					DrawStr(117,40,"Good!",A_NORMAL);
					press=0, skip=1, points+=5, combo=0;
				}
			}
		}
		// When y equals 5
		if(y==5) {
			if(skip==1) {
				goto speed;
			}
			if(l==1) {
				press=_keytest (RR_LEFT);
				if(press==1) {
					DrawStr(27,40,"Great!",A_NORMAL);
					press=0, skip=1, points+=10, combo+=1;
				}
			}
			if(r==1) {
				press=_keytest (RR_RIGHT);
				if(press==1) {
					DrawStr(57,40,"Great!",A_NORMAL);
					press=0, skip=1, points+=10, combo+=1;
				}
			}
			if(u==1) {
				press=_keytest (RR_UP);
				if(press==1) {
					DrawStr(87,40,"Great!",A_NORMAL);
					press=0, skip=1, points+=10, combo+=1;
				}
			}
			if(d==1) {
				press=_keytest (RR_DOWN);
				if(press==1) {
					DrawStr(117,40,"Great!",A_NORMAL);
					press=0, skip=1, points+=10, combo+=1;
				}
			}
		}
		// When y equals 4
		if(y==4) {
			if(skip==1) {
				goto speed;
			}
			if(l==1) {
				press=_keytest (RR_LEFT);
				if(press==1) {
					DrawStr(24,40,"Perfect!",A_NORMAL);
					points+=50, combo+=1, press=0, skip=1;
				}
			}
			if(r==1) {
				press=_keytest (RR_RIGHT);
				if(press==1) {
					DrawStr(54,40,"Perfect!",A_NORMAL);
					points+=50, combo+=1, press=0, skip=1;
				}
			}
			if(u==1) {
				press=_keytest (RR_UP);
				if(press==1) {
					DrawStr(84,40,"Perfect!",A_NORMAL);
					points+=50, combo+=1, press=0, skip=1;
				}
			}
			if(d==1) {
				press=_keytest (RR_DOWN);
				if(press==1) {
					DrawStr(112,40,"Perfect!",A_NORMAL);
					points+=50, combo+=1, press=0, skip=1;
				}
			}
		}
		// When y equals 3
		if(y==3) {
			if(skip==1) {
				goto speed;
			}
			if(l==1) {
				press=_keytest (RR_LEFT);
				if(press==1) {
					DrawStr(27,40,"Great!",A_NORMAL);
					press=0, skip=1, points+=10, combo+=1;
				}
			}
			if(r==1) {
				press=_keytest (RR_RIGHT);
				if(press==1) {
					DrawStr(57,40,"Great!",A_NORMAL);
					press=0, skip=1, points+=10, combo+=1;
				}
			}
			if(u==1) {
				press=_keytest (RR_UP);
				if(press==1) {
					DrawStr(87,40,"Great!",A_NORMAL);
					press=0, skip=1, points+=10, combo+=1;
				}
			}
			if(d==1) {
				press=_keytest (RR_DOWN);
				if(press==1) {
					DrawStr(117,40,"Great!",A_NORMAL);
					press=0, skip=1, points+=10, combo+=1;
				}
			}
		}
		
		
		// When y equals 2
		if(y==2) {
			if(skip==1) {
				goto speed;
			}
			if(l==1) {
				press=_keytest (RR_LEFT);
				if(press==1) {
					DrawStr(27,40,"Good!",A_NORMAL);
					press=0, skip=1, points+=5, combo=0;
				}
			}
			if(r==1) {
				press=_keytest (RR_RIGHT);
				if(press==1) {
					DrawStr(57,40,"Good!",A_NORMAL);
					press=0, skip=1, points+=5, combo=0;
				}
			}
			if(u==1) {
				press=_keytest (RR_UP);
				if(press==1) {
					DrawStr(87,40,"Good!",A_NORMAL);
					press=0, skip=1, points+=5, combo=0;
				}
			}
			if(d==1) {
				press=_keytest (RR_DOWN);
				if(press==1) {
					DrawStr(117,40,"Good!",A_NORMAL);
					press=0, skip=1, points+=5, combo=0;
				}
			}
		}
		
		
		// When y equals 1
		if(y==1) {
			if(skip==1) {
				goto speed;
			}
			if(l==1) {
				press=_keytest (RR_LEFT);
				if(press==1) {
					DrawStr(27,40,"Bad",A_NORMAL);
					points+=1, combo=0;
				}
				if(press==0) {
					DrawStr(27,40,"Miss",A_NORMAL);
					combo=0;
				}
				press=0, skip=1;
			}
			if(r==1) {
				press=_keytest (RR_RIGHT);
				if(press==1) {
					DrawStr(57,40,"Bad",A_NORMAL);
					points+=1, combo=0;
				}
				if(press==0) {
					DrawStr(57,40,"Miss",A_NORMAL);
					combo=0;
				}
				press=0, skip=1;
			}
			if(u==1) {
				press=_keytest (RR_UP);
				if(press==1) {
					DrawStr(87,40,"Bad",A_NORMAL);
					points+=1, combo=0;
				}
				if(press==0) {
					DrawStr(87,40,"Miss",A_NORMAL);
					combo=0;
				}
				press=0, skip=1;
			}
			if(d==1) {
				press=_keytest (RR_DOWN);
				if(press==1) {
					DrawStr(117, 40,"Bad",A_NORMAL);
					points+=1, combo=0;
				}
				if(press==0) {
					DrawStr(117,40,"Miss",A_NORMAL);
					combo=0;
				}
				press=0, skip=1;
			}
		}
		
		
		// Speed Control
		speed:
		while(wait!=7000) {
			wait++;
		}
		wait=0;
		
		press=_keytest (RR_ESC);
		if(press==1) {
			goto end;
		}
	}
	move=0;
	if(l==1) {
		Sprite8(30,y,8,left,LCD_MEM,SPRT_XOR);
	}
	if(r==1) {
		Sprite8(60,y,8,right,LCD_MEM,SPRT_XOR);
	}
	if(u==1) {
		Sprite8(90,y,8,up,LCD_MEM,SPRT_XOR);
	}
	if(d==1) {
		Sprite8(120,y,8,down,LCD_MEM,SPRT_XOR);
	}
	y=90, l=0, r=0, u=0,d=0, t=0;
	}
	// Pause Screen
	pause:
	BitmapGet (&full_screen, screen);
	FontSetSys(F_8x10);
	if(l==1) {
		Sprite8(30,y,8,left,LCD_MEM,SPRT_XOR);
	}
	if(r==1) {
		Sprite8(60,y,8,right,LCD_MEM,SPRT_XOR);
	}
	if(u==1) {
		Sprite8(90,y,8,up,LCD_MEM,SPRT_XOR);
	}
	if(d==1) {
		Sprite8(120,y,8,down,LCD_MEM,SPRT_XOR);
	}
	DrawStr(55,50,"PAUSED",A_NORMAL);
	DrawLine(0,46,159,46,A_NORMAL);
	DrawLine(0,62,159,62,A_NORMAL);
	while(x<52) {
		DrawLine(x+5,46,x,62,A_NORMAL);
		x+=5;
	}
	x=102;
	while(x<154) {
		DrawLine(x+5,46,x,62,A_NORMAL);
		x+=5;
	}
	x=0;
	h=0;
	while(h!=3000000) {
		h++;
	}
	while(y!=100) {
		press=_keytest (RR_F1);
		if(press==1) {
			FontSetSys(F_4x6);
			if(l==1) {
			Sprite8(30,y,8,left,LCD_MEM,SPRT_XOR);
			}
			if(r==1) {
				Sprite8(60,y,8,right,LCD_MEM,SPRT_XOR);
			}
			if(u==1) {
				Sprite8(90,y,8,up,LCD_MEM,SPRT_XOR);
			}
			if(d==1) {
				Sprite8(120,y,8,down,LCD_MEM,SPRT_XOR);
			}
				ClrScr();
				BitmapPut (0, 0, screen, &full_screen, A_REPLACE);
				pt=1, p=0;
				goto play;
		}
	}
	
	end:
	OSSetSR (0x0000);
	ClrScr();
}
